#! /bin/sh

##
## make libCMU
##

#----------------------
MAKE=$1 ; export MAKE
#----------------------

if [ ! -f .patch.cmu98 -a ! -d libCMU -a ! -d CMUnited98-source ] ; then
	if [ -f CMUnited98-source.tar.gz ] ; then
	    echo "Decompress archive file" ;
	    gzip -dc CMUnited98-source.tar.gz| tar xvf - ;
	    cp -rp CMUnited98-source libCMU ;
	    echo "patch -c -d libCMU < cmu98-libCMU98.diff" ;
	    patch -c -d libCMU < cmu98-libCMU98.diff ;
	    touch '.patch.cmu98' ;
	    echo "make and install" ;
	    if [ X`uname` = X'SunOS' ] ;then
		(cd libCMU && $MAKE -f Makefile.Solaris) ;
	    else
		(cd libCMU && $MAKE) ;
	    fi
	    echo "install (^^;  libCMU98" ;
#	    cp libCMU98/libCMU.a ../../lib/libCMU.a ;
	    cp libCMU/libCMU.a ./lib ;
	    cp libCMU/*.h ./include ;
	else
	    echo "<CMUnited98 source code> " ;
	    echo "    URL = http://www.cs.cmu.edu/~robosoccer" ;
	    echo "    follow the links to simlator team, and CMUnited98,CMUniterd99 source code" ;
	    echo "--------------------------------------------";
	    echo "<< How To Make Library >>" ;
	    echo "1) get source archive and put src/CMU/      ";
	    echo "2) make ";
	    echo "--------------------------------------------";
	    exit 1 ;
	fi
elif [ -d libCMU -a -d CMUnited98-source ] ; then
	if [ ! -f .patch.cmu98 ] ; then
		echo "patch -c -d libCMU < cmu98-libCMU98.diff" ;
		patch -c -d libCMU < cmu98-libCMU98.diff ;
		touch '.patch.cmu98' ;
		echo "make and install" ;
		if [ X`uname` = X'SunOS' ] ;then
		    (cd libCMU && $MAKE -f Makefile.Solaris) ;
		else
		    (cd libCMU && $MAKE all) ;
		fi
		echo "install (^^;  libCMU98" ;
#		cp libCMU98/libCMU.a ../../lib/libCMU.a ;
		cp libCMU/libCMU.a ./lib ;
		cp libCMU/*.h ./include ;
	else
		echo "make and install" ;
		if [ X`uname` = X'SunOS' ] ;then
		    (cd libCMU && $MAKE -f Makefile.Solaris) ;
		else
		    (cd libCMU && $MAKE) ;
		fi
		echo "install (^^;  libCMU98" ;
#		cp libCMU98/libCMU.a ../../lib/libCMU.a ;
		cp libCMU/libCMU.a ./lib ;
		cp libCMU/*.h ./include ;
	fi
fi
