#include <libCMU.h>
#include "soccer.h"

void before_centering();
void after_centering();


//-------------------
//   
//-------------------
Action OF_run_select()
{
	printf("%d  OF_run_select\n",Mem->MyNumber);

	Vector ballvel = Mem->BallAbsoluteVelocity();
	Vector ball    = Mem->BallAbsolutePosition();
	Vector my_pos  = Mem->MyPos();
	Vector center;
	center.x = 47.5; center.y = 0;
	Vector p1,p2,p3,p4;
	p1.x = center.x - 5; p1.y = center.y + 5;
	p2.x = center.x - 5; p2.y = center.y - 5;
	p3.x = center.x + 5; p3.y = center.y + 5;
	p4.x = center.x - 5; p4.y = center.y - 5;

	Vector my_center;
	my_center = my_pos;
	Vector my_p1,my_p2,my_p3,my_p4;
	my_p1.x = my_center.x - 5; my_p1.y = my_center.y + 5;
	my_p2.x = my_center.x - 5; my_p2.y = my_center.y - 5;
	my_p3.x = my_center.x + 5; my_p3.y = my_center.y + 5;
	my_p4.x = my_center.x - 5; my_p4.y = my_center.y - 5;


	Vector near_side, far_side;
	near_side.x = far_side.x = offside_line() - 2;
	if(ball.y > 0){
		near_side.y = 5.5;
		far_side.y = -5.5;
	}else{
		near_side.y = -5.5;
		far_side.y = 5.5;
	}

	// ֶᤤʤܡ˹Ԥ
	if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
		get_ball();

	}else if(ball.x < 0){
		new_position();

 	// 󥿥󥰤夲Ƥʤ⡩
	}else if(Mem->BallSpeed() < 1){
		before_centering();
	// ˤʥ륨ꥢ
	}else if((ball.x > p1.x) && (fabs(ball.y) < fabs(p1.y))){

		if(Mem->ClosestTeammateTo(near_side))
			go_to_point(near_side);
		else
			go_to_point(far_side);

	// Ǥ
	}else if(ball.x > 20){	
		if(ball.y > center.y){
			if((p2.y - ball.y) / (p2.x - ball.x) >= (ballvel.y / ballvel.x) && 
		   	 ((p3.y - ball.y) / (p3.x - ball.x) <= (ballvel.y / ballvel.x))){
				after_centering();
				return AC_your_centering;
			}else{
				before_centering();
			}
		}else if(ball.y < center.y){
			if((p1.y - ball.y) / (p1.x - ball.x) >= (ballvel.y / ballvel.x) && 
		   	 ((p4.y - ball.y) / (p4.x - ball.x) <= (ballvel.y / ballvel.x))){
				after_centering();
				return AC_your_centering;
			}else{
				before_centering();
			}
		}
	// ʬǤ

	}else if(Mem->BallDistance() < 20 && ball.y > my_center.y){
		if((my_p2.y - ball.y) / (my_p2.x - ball.x) >= (ballvel.y / ballvel.x) && 
		    ((my_p3.y - ball.y) / (my_p3.x - ball.x) <= (ballvel.y / ballvel.x))){
			get_ball();
		}else{
			new_position();
		}
	}else if(Mem->BallDistance() < 20 && ball.y < my_center.y){
		if((my_p1.y - ball.y) / (my_p1.x - ball.x) >= (ballvel.y / ballvel.x) && 
		    ((my_p4.y - ball.y) / (my_p4.x - ball.x) <= (ballvel.y / ballvel.x))){
			get_ball();
		}else{
			new_position();
		}
	}else{
//		new_position();
		go_to_point(Vector(offside_line() - 2, Mem->MyY()), 0, 100);
	}


	return AC_OF;
}

//--------------------
//   󥿥󥰸
//--------------------
void after_centering()
{
	printf("%d after_centering\n",Mem->MyNumber);

	Vector center;
	center.x = 47.5; center.y = 0;
	Vector ball = Mem->BallAbsolutePosition();
	float ballspeed = Mem->BallSpeed();
	Vector point;

	float dis = ball.dist(center);

	if(dis > 20 && ballspeed > 2.0){
		if(fabs(Mem->MyPos().y) > 10){
			go_to_point(center);
		}else{
			point.x = 50;
			if(ball.y > 0){
				point.y = -5;
			}else{
				point.y = 5;
			}
			go_to_point(point);
		}
	}else if(ball.x < 7){
		get_ball();
	}else{ 
		get_ball();
	}

}
//--------------------
//   󥿥
//--------------------
void before_centering()
{
	printf("%d before_centering\n",Mem->MyNumber);

	Vector vec;

	float line = offside_line();

	if(Mem->BallPositionValid() < 0.8){
		face_ball();
		return;
	}

	vec.x = line - 1;

	if(Mem->PlayerWithBall(-4) > 0){
		//ɤǥܡäƤ
		if(fabs(Mem->TeammateY(Mem->TeammateWithBall(-4))) > 15){
			if(Mem->TeammateY(Mem->TeammateWithBall(-4)) > 0){
				if((Mem->MyNumber % 2) == 0){
					vec.y = -1;
					vec.x -= 2;
				}else{
					vec.y = -10;
				}
			}else{
				if((Mem->MyNumber % 2) == 0){
					vec.y = 10;
				}else{
					vec.y = -1;
					vec.x -= 2;
				}
			}
		}else{  //ǻäƤ
			if((Mem->MyNumber % 2) == 0){
				vec.y = 8;
			}else{
				vec.y = -8;
			}
		}

	}else{
       		new_position();
		return;
	}


	if(go_to_point(vec, 0.8, 100) == AQ_ActionNotQueued)
		face_ball();

}
