#ifndef	   SOCCER_ACTION_H_INCLUDED
#define	   SOCCER_ACTION_H_INCLUDED

#include  "soccer_composite_command.h"
#include  "field_recog_abstract.h"
#include  "ref_count_ptr.h"

class  Soccer_Action
{
private:
	bool	fin;

protected:
	typedef  const ref_count_ptr<Field_Recog_Abstract> &  FR_Info;

	FR_Info		field;
	void		set_finished() throw();
	void		reset_finished() throw();

public:
	 Soccer_Action( FR_Info ) throw();
virtual	~Soccer_Action() throw();

virtual	Soccer_Composite_Command	get_command() = 0;

virtual	bool				finished() const throw();
};


#endif	/* SOCCER_ACTION_H_INCLUDED */
