#ifndef	   QUANTIZE_H_INCLUDED
#define	   QUANTIZE_H_INCLUDED

static	const	double	SERVER_EPS = (1.0e-10);
static	const	double	FAR_OBJECT_UNQUANTIZE_DEFAULT_MAX_ERROR = (0.01);

extern	double	far_object_distance( double  x );
extern	void	far_object_unquantized_distance(
			double  x ,
			double *  x_min ,
			double *  x_max ,
			double  max_error
				 = FAR_OBJECT_UNQUANTIZE_DEFAULT_MAX_ERROR );

extern	double	quantize( double  x ,  double  q );
extern	void	unquantize( double  x ,  double  q ,
			    double *  x_min ,  double *  x_max );


#endif	/* QUANTIZE_H_INCLUDED */
