#include <libCMU.h>
#include <zeng.h>

// DH
void DH_behave()
{
	double buffer = minimal_buffer() ;
	if ( mode_action() == TRUE ) return ;

// DH
/*ܡ뤬ʤ*/
	if (!Mem->BallPositionValid()){
		face_ball();
	}
	else
	{
		if ( Mem->BallKickable() )
		{
			double danger_val = get_danger_val ( 25 ) ;

			if ( Mem->BallMoving() )
			{
				if (Mem->BallVelocityValid() &&
				    Mem->BallAbsoluteVelocity().mod() > 1.6 )
				{
					stop_ball() ;
					return ;
				}
			}

			if ( shoot_near_post() == TRUE ) return ;

			Vector vec = Vector ( 10 , 0 ) ;

			if ( danger_val < 0.3 )
			{
				if ( Mem->my_offside_line <= 15 && Mem->MyX() < 30 )
				{
					if ( forward_pass(Vector(30,0)) == TRUE ) return ;
				}

				if ( MF_pass_forward () == TRUE )	return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;

				if ( DR_None == DribbleTo(vec , 100 , 0 , Mem->CP_dribble_angle_norm,
					  DM_Lazy, FALSE, vec ) )
				{
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_side () == TRUE )	return ;
					if ( MF_pass_center () == TRUE ) return ;
					if ( shoot_near_post() == TRUE ) return ;

				}
				return ;
			}
			else if ( danger_val < 0.6 )
			{
				if ( Mem->my_offside_line <= 15 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;
			}
			else
			{
				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE )
				{
					return ;
				}
				else
				{
					if ( Mem->DistanceTo(Vector(36.0,10)) > 10 )
					{
						//hold_ball() ;
						kick_ball (Vector ( 36.0 , 15 ) , KM_HardestKick ,TURN_AVOID) ;
					}
					else
					{
						//hold_ball() ;
						kick_ball (Vector ( 36.0 , -15 ) , KM_HardestKick ,TURN_AVOID) ;
					}

					return ;
				}
			}
		}
		else if ( ball_to_my ( 6.0 ) == TRUE )
		{
			if ( get_ball_to_own(buffer) == TRUE )
			{
				return ;
			}
			else
			{
				face_ball() ;
				return ;
			}
		}
		else if ( how_many_closer_teammate(Mem->BallAbsolutePosition() ) < 2 )
// DH
		{
#if 1
			if ( Mem-> BallInOwnPenaltyArea() )
			{
				if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
				{
					if ( go_to_point ( Mem->BallAbsolutePosition() ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
					return ;
				}
				else
				{
					if ( go_to_pos(20)  == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
					return ;
				}
			}
			else
			{
				chase_ball(buffer);
				return ;
			}
#else
			chase_ball(buffer);
#endif
		}
// DH
		else if ( Mem->BallWillBeKickable( 5 , 100 ) )
		{
			if (Mem->PlayerWithBall() <= 0)/*ŨܡäƤ*/
			{
				if ( go_to_point(Vector(Mem->BallAbsolutePosition().x - 2 , Mem->BallAbsolutePosition().y - (Mem->BallY()>0?0.5:-0.5)) ,buffer) ==AQ_ActionNotQueued )
				{
					face_ball() ;
					return ;
				}
			}
			else
			{
				chase_ball(buffer) ;
				return ;
			}
		}
		else
		{
			if ( Mem->BallPositionValid() )
			{
				if ( Mem->BallX() > 10 )
				{
					Vector v ;
					v = Vector ( Mem->BallX() - 10 , MyProp->pos.y ) ;
					if ( v.x >= 0 )
						v.x = 0 ;
					if (go_to_point( v , -10 , 40 ) == AQ_ActionNotQueued )
					{
						face_ball();
						return ;
					}
					return ;
				}
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x ) < 10  && Mem->BallX() > -5 )
				{
					if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->BallAbsolutePosition().x - 5 , MyProp->init_pos.y),buffer) )
					{
						face_ball() ;
						return ;
					}
					return ;
				}
#if 0
				else if ( Mem -> BallAbsolutePosition().x > 15 )
				{
					if  ( go_to_point ( MyProp -> pos , buffer , 40 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
					return ;
				}
#endif
#if 0
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x ) > 10  )
				{
					if ( Mem->TeammateInOffsidePosition(Mem->MyNumber) )
					{
						if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->BallAbsolutePosition().x - 5 , MyProp->init_pos.y),buffer) )
						{
							face_ball() ;
						}
					}
					else
					{
						if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->BallAbsolutePosition().x - 10 , MyProp->init_pos.y),buffer) )
						{
							face_ball() ;
						}
					}
					return ;
				}
#endif
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x) > 5
					  && (Mem-> BallAbsolutePosition().x < Mem->MyPos().x ) )
				{
					if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->BallAbsolutePosition().x - 3 ,MyProp->init_pos.y),buffer) )
					{
						face_ball() ;
					}
					return ;
				}
				else
				{
					if ( Mem->TeammateInOffsidePosition(Mem->MyNumber) )
					{
						if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->my_offside_line - 15  , MyProp->init_pos.y),buffer))
						{
							face_ball() ;
						}
					}
					else
					{
						double x = Mem->their_offside_line ;
						if ( x < -40 )
							x = -40 ;

						if ( x < -10 )
							x = x + 15 ;
						else
							x = x + 20 ;

						if ( AQ_ActionNotQueued == go_to_point(Vector(x  , MyProp->init_pos.y),buffer))
						{
							face_ball() ;
						}
					}
					return ;
				}
			}
			else
			{
				if ( AQ_ActionNotQueued == go_to_point(MyProp->init_pos.y,buffer,30 ) ) ;
				{
					face_ball() ;
				}
			}
		}
	}
}
