#! /bin/sh

host="localhost"
port="6000"
team="Zeng99"
goalie=0
num=2
renum=2

while [ $# -gt 0 ]
do
    case $1 in
    -h*)
	host=$2
	shift 1
	;;
    -p*)
	port=$2
	shift 1
	;;
    -r*)
	num=$2
	renum=$3
	shift 2
	;;
    -t*)
	team=$2
	shift 1
	;;
    -g)
	goalie=1
	;;
    esac
    shift 1
done

echo $team $host $port $num $renum

./field_player\
	    -file client.conf -file server.conf \
	    -team_name $team \
	    -host $host \
	    -port $port \
	    -role $num -reconnect $renum 1> /dev/null 2>&1 &
