#! /bin/sh

host="localhost"
port="6000"
team="Zeng99"
goalie=0

while [ $# -gt 0 ]
do
    case $1 in
    -h*)
	host=$2
	shift 1
	;;
    -p*)
	port=$2
	shift 1
	;;
    -t*)
	team=$2
	shift 1
	;;
    -g)
	goalie=1
	;;
    esac
    shift 1
done

#for num in 2 3 4 5 6 7 8 9
for num in 2 3 4 5 6 7 8 9
do
    sleep 1
    ./field_player\
	    -file client.conf -file server.conf \
	    -team_name $team \
	    -host $host \
	    -port $port \
	    -role $num 1> /dev/null 2>&1 &
done
