#ifndef	   ZENG_H_INCLUDED
#define	   ZENG_H_INCLUDED


/* go_to_ball ,Aoyagi*/
Bool ball_to_point(Vector point, float buffer) ;
Bool ball_to_my(float buffer) ;

/* go_to_ball ,Aoyagi*/
Bool get_ball_to_own ( double buffer ) ;

//change stamina low limit parameter
void change_stamina_limit ( float new_limit = 10 ) ;

//check
void check_all( void ) ;
void check_stamina(void) ;
void check_ball ( void ) ;
void check_offside_line ( void ) ;
void check_player ( void ) ;
void check_counter( void ) ;

//dance (^^;
void dancing ( int limit ) ;
void move_dance_position ( int counter ) ;

//dash move (^^;
void dash_init_position_with_move ( Vector position , int limit = 40 ) ;

double minimal_buffer() ;

void move_to_initial_pos();

ActionQueueRes go_to_initial_pos(double pow);
ActionQueueRes go_to_pos(double pow);
ActionQueueRes go_to_pos2(double pow);

//temporary function
double get_danger_val ( double dist ) ;
double get_danger_val_player ( float dist ) ;
Bool player_is_dribble ( void ) ;

Bool kick_to_xy(class Vector) ;
Bool kick_to (class Vector) ;


Bool chase_ball(double buffer = 0 ) ;


Bool before_kick_off() ;
//mode_action 
Bool mode_action(void) ;
Bool my_kick_in(void) ;
Bool their_kick_in(void) ;

Bool kick_in_center() ;
Bool kick_in_forward() ;

Bool their_free_kick(void) ;
Bool their_offside_kick(void) ;
Bool their_kick_in(void) ;
Bool their_kick_off(void) ;
Bool their_goal_kick(void) ;

Bool my_free_kick(void) ;
Bool my_offside_kick(void) ;
Bool my_kick_in(void) ;
Bool my_kick_off(void) ;
Bool my_goal_kick(void) ;

Bool their_corner_kick(void) ;
Bool my_corner_kick(void) ;

//shoot
Bool shoot_near_post ( void ) ;
Bool shoot_near_post ( int dist ) ;

//pass check
Bool pass_check(Unum unum) ;
Bool pass_check1(Unum unum) ;
Bool pass_check2(Unum unum) ;
Bool pass_check3(Unum unum) ;

//pass
Bool DF_pass_forward() ;
Bool MF_pass_forward() ;
Bool MF_pass_center() ;
Bool MF_pass_side() ;
Bool pass_centering ( Unum u ) ;
Bool center_pass ( Vector vec ) ;
Bool through_pass(Unum u) ;
Bool forward_pass(class Vector) ;

//clear
Bool MF_clear() ;
void DF_clear() ;
void SW_clear() ;

//go to point
void return_to_initial_pos(int dash_pow);

//position
Bool DF_Pos1() ;
Bool DF_Pos2() ;
Bool DF_Pos3() ;


//Bool go_to_mark_position ( Vector point ) ;

//Bool my_go_to_position ( Vector v1 , Vector v2 , double dist , double vel ) ;
Bool my_go_to_position ( Vector v1 , Vector v2 , double dist , double vel ,double buffer ) ;

int how_many_closer_teammate(Vector v);


void behave();
//main behave functions
void GK_behave();
void SW_behave();
void DH_behave();
void DF_behave();

void LMF_behave();
void RMF_behave();
void LSMF_behave();
void RSMF_behave();
void CMF_behave();
void OH_behave();

void RFW_behave();
void LFW_behave();

struct Property {
  Vector init_pos;
  Vector init_pos2;
  Vector of_pos;
  Vector df_pos;
  Vector pos;
  Vector pos2;

  double offside_line_offset ;
  double shoot_distance ;
  double offside_line_value ;
  double x_upper_limit ;

  //position , temporary
  Vector beforekickoff ;
  Vector my_kickoff ;
  Vector their_kickoff ;
  Vector my_kickin ;
  Vector their_kickin ;
  Vector my_freekick ;
  Vector their_freekick ;
  Vector my_offsidekick ;
  Vector their_offsidekick ;
  Vector my_cornerkick ;
  Vector their_cornerkick ;
  Vector my_goalkick ;
  Vector their_goalkick ;

  Vector my_freekick_point ;
  Vector my_offsidekick_point ;
  Vector my_cornerkick_point ;

  //role
  void (*my_behave)(void);
};

extern Property *MyProp;

//(^^;
extern int dance_counter ;
extern int move_counter ;
extern int say_counter ;

//not implemented
#if 0
Enum HighBehave
{
	None,
	CounterAtack,
	SideAtack
	//	DefenceAction,
	//	OffenseAction
} ;

Enum MiddleBehave
{
	None,
	//
	Shoot,
	Balltrap,

	Pass,
	PassCenter,
	PassForward,
	PassSide,
	ThroughPass,
	ForwardPass,

	Dribble,
	Ballclear,
	//
	Gotoball,
	//
	Positioning,
	//
	Ballsearch,

	BeforeKickOff,
	//
	MyKickOff,
	MyKickIn,
	MyFreeKick,
	MyGoalKick,
	MyCornerKick,
	MyOffsideKick,
	//
	TheirKickOff,
	TheirKickIn,
	TheirFreeKick,
	TheirGoalKick,
	TheirCornerKick,
	TheirOffsideKick
} ;

Enum LowBehave
{
	None,
	Dash,
	Turn,
	Kick,
	Catch,
	SenseBody,
	Move,
	Say,
	Bye,
	ChangeView,
	TurnNeck
} ;

HighBehave higher_level_layer(int role) ;
MiddleBehave middle_level_layer(int role,HighBehave behave_num ) ;
LowBehave lower_level_layer (int role,MiddleBehave behave_num ) ;
#endif

//position , temporary
Vector get_position_beforekickoff ( int num ) ; 
Vector get_position_my_kickoff ( int num ) ;    
Vector get_position_their_kickoff ( int num ) ; 
Vector get_position_my_kickin ( int num ) ;     
Vector get_position_their_kickin ( int num ) ;  
Vector get_position_my_freekick ( int num ) ;   
Vector get_position_their_freekick ( int num ) ;
Vector get_position_my_offside ( int num ) ;    
Vector get_position_their_offside ( int num ) ; 
Vector get_position_my_cornerkick ( int num ) ; 
Vector get_position_their_cornerkick ( int num ) ;
Vector get_position_my_goalkick ( int num ) ;   
Vector get_position_their_goalkick ( int num ) ;

Vector get_position_my_freekick_point ( int num ) ;
Vector get_position_my_offsidekick_point ( int num ) ;

#ifdef CMU99
ActionQueueRes face_ball(void) ;
ActionQueueRes scan_field(void) ;
#endif

#endif	/* CLIENT_H_INCLUDED */
