#include <libCMU.h>


#define Unum_Unknown 0
#define LAST_SHOOT_DIS 16
#define SECOND_SHOOT_DIS 20

enum Part{
	GK,
	SW,
	DF,
	RWB,
	LWB,
	FMF,
	DMF,
	RMF,
	LMF,
	MF,
	CF,
	WF,
	FW
};

enum ball_pos{ // ܡΰ
	pos0,   // ʬʤ 
	pos1,   // 
	pos2,   // 沼
	pos3,   // 
	pos4,   // 
	pos5,   // 
	pos6,   // 
	pos7,   // 
	pos8,   // 
	pos9    // 
};


typedef struct {
	Part part;    // ʬ䡡FWDFMF

	Vector p0;   // ϤΥݥ
	Vector p1;   // ưݥ
} Position ;


enum Action{
	AC_none,
	AC_dribble,
	AC_pass,
	AC_DF,
	AC_OF,
	AC_shoot,
	AC_post,
	AC_turn,
	AC_your_dribble,
	AC_your_centering
};

//---------------------
//  HFCΥإå
//---------------------
void formation();     // åդλΥݥ

//---------------------
// position Υإå
//---------------------

void new_position();  // ʬοݥ
void their_goal_position(); // 륭åѡåΥݥ
void their_kick_in_position(); // ΥåλΥݥ
void my_kick_in_position(); // ̣ΥåλΥݥ

//---------------------
// playΥإå
//---------------------
void covering(); // С
Bool pass();   // ѥλ
Bool offside_trap_check();  // եɥȥåפǽ
void offside_trap();   // եɥȥå
Action pass_select();   // ѥνФ
void run_select();    // 
void FW_dribble();    // FWΥɥ֥
Action post_play();     // ݥȥץ졼
Action dribble();       // ɥ֥
Bool my_turn();       // ¦ʤ饿
void my_kick(Vector point);  //point˥å
void my_kick(int power, Vector point);
Action DF_run_select();
void my_dribbleto(Vector point,float max_dash_pow, float buffer);


//----------------------
//   helpΥإå
//----------------------
Unum who_pass_team();  // ï˥ܡ뤬äƤ뤫
int my_in_cone_team(Vector vec);  // ʬΥ̣ͤ뤫
int ball_in_cone_opp(Vector vec);  // ܡ뤫ΥŨͤ뤫
int my_in_cone_opp(Vector vec);  // ʬΥŨͤ뤫
Bool my_stop_ball(); // ܡߤ
Unum first_intercepter(); // ïֻϤ˥󥿡ץȤǤ뤫
Bool pass_receive(); // ѥץ졼䡼
Unum last_with_ball_teammate();  // ѥФץ졼䡼
float pass_check_priority(Unum player);
int pass_priority(Unum* player); // ѥͥ
int front_player(Unum* player); // ̣ν
Bool kick_to_xy ( Vector pos ); //   κɸ˥å
Bool kick_to ( Vector pos ); // ȵΥ˥å
void shoot1();  // 塼ȤɤäΥɤǤ
Vector ball_stop_position();  // ܡ뤬ɤ˻ߤޤ뤫
float DF_offside_line();  // DFΥեɥ饤
float offside_line();  // եɥ饤
Bool teammate_offside(Unum unum);  // ̣եɤɤ
Bool ball_to_my(float buffer);  // ܡ뤬ʬ˸äƤ뤫
Bool ball_to_point(Vector point, float buffer); // ܡ뤬ݥȤ˸äƤ뤫
Bool pass_check(Unum unum);
Vector space_forward();
Vector space();
AngleDeg angle_point_to_point(Vector point1,Vector point2);
void go_ball();  // ܡ˹Ԥ
ball_pos ball_position(); // ܡΰ
int how_many_closer_teammate(Vector v); // ʬܡ˲ܤ˶ᤤ


enum Face{      // θ
	face_none,
	face_forward,
	face_back,
	face_fright,
	face_fleft,
	face_bright,
	face_bleft
};

Face my_face();
Face teammate_face(Unum n);
Face opponent_face(Unum n);
Bool face_to_bool(Unum n ,Vector vec);


//----------------------
//   OFΥإå
//----------------------
Action OF_run_select();


//----------------------
//   shootΥإå
//----------------------
void init();
Action shoot();         // 塼
void part_1_vs_1(Unum goali_unum);
void part_1_vs_2(Unum goali_unum, Unum near_tea_unum);
void part_2_vs_1(Unum goali_unum, Unum near_opp_unum);
void part_2_vs_2(Unum goali_unum, Unum near_opp_unum, Unum near_tea_unum);

extern int dance_counter ;
extern int say_counter ;


