#ifndef	   SOCCER_OPTION_ANALYZER_H_INCLUDED
#define	   SOCCER_OPTION_ANALYZER_H_INCLUDED

#include  <string>
#include  <iostream>
#include  "ip_address.h"
#include  "sserver_param.h"

class  Soccer_Option_Analyzer
{
protected:
	bool		valid;

	std::string	host;
	in_port_t	port;
	std::string	team;
	bool		reconnect_flag;
	int		reconnect_player_num;

	std::string	argv_0;

public:
	 Soccer_Option_Analyzer( int  argc ,  char  *argv[] ,
				 std::string  default_team_name ,
				 std::string  default_host_name = "localhost" ,
				 in_port_t  default_port_number
				     = SServer_Param::SSERVER_DEFAULT_PORT );

	~Soccer_Option_Analyzer();

	void   usage( std::ostream &  ostr = cerr ) const throw();

	operator  bool() const throw();

	std::string	teamname() const throw();
	std::string	hostname() const throw();
	in_port_t	port_number() const throw();
	bool		reconnect() const throw();
	int		reconnect_player_number() const throw();
};


#endif	/* SOCCER_OPTION_ANALYZER_H_INCLUDED */
