#include <libCMU.h>
#include <zeng.h>

void GK_behave()
{
	double buffer = minimal_buffer();
	if ( mode_action() == TRUE ) return ;

	if (!Mem->BallPositionValid())
	{
		face_ball();
		return ;
	}
	else
	{
		if ( Mem->BallCatchable() )
		{
			goalie_catch ( Mem->BallAbsolutePosition().dir() ) ;
			return ;
		}
		else if (Mem->BallKickable())
		{
			//GK_clear();
			DF_clear();
			return ;
		}
#if 0
		else if ( Mem->BallWillBeCatchable(5, 100) )
		{
			if ( AQ_ActionNotQueued == go_to_point( Mem->BallPredictedPosition(5)) )
			{
				face_ball() ;
				return ;
			}
			return ;
		}
#endif
		else if ( Mem->BallWillBeKickable(5, 100) )
		{
			if ( AQ_ActionNotQueued == go_to_point( Mem->BallPredictedPosition(5)) )
			{
				face_ball() ;
				return ;
			}
			return ;
		}
		else
		{
			Vector goal_p ;
			
			if ( Mem->BallY() < -20 )
			{
				goal_p = Vector ( -50.5 , 0 - 3.0 ) ;
			}
			else if ( Mem->BallY() < -10 )
			{
				goal_p = Vector ( -50.5 , 0 - 2.0 ) ;
			}
			else if ( Mem->BallY() >= -1 && Mem->BallY() <= 1 )
			{
				goal_p = Vector ( -50.5 , 0.0 ) ;
			}
			else if ( Mem->BallY() < 10  )
			{
				goal_p = Vector ( -50.5 , 0 + 2.0 ) ;
			}
			else if ( Mem->BallY() < 20 )
			{
				goal_p = Vector ( -50.5 , 0 + 3.0 ) ;
			}
			else
			{
				goal_p = Vector ( -50.5 , 0.0 ) ;
			}

			if ( my_go_to_position ( goal_p , Mem->BallAbsolutePosition()  , 11.0 , 100 , 0.3 ) != TRUE )
			{
				face_ball() ;
			}

			return ;
		}
	}
}
