#include <libCMU.h>
#include <zeng.h>

void OH_behave()
{
	double buffer = minimal_buffer() ;
	if ( mode_action() == TRUE ) return ;

// OH
/*ܡ뤬ʤ*/
	if (!Mem->BallPositionValid()){
		face_ball();
	}
	else
	{
		if ( Mem->BallKickable() )
		{
			double danger_val = get_danger_val ( 20 ) ;
#if 1
			if ( Mem->BallMoving() )
			{
				if (Mem->BallVelocityValid() &&
				    Mem->BallAbsoluteVelocity().mod() > 1.8 )
				{
					stop_ball() ;
					return ;
				}
			}
#endif
			if ( shoot_near_post() == TRUE ) return ;

			Vector vec = Vector ( 38 , 10 ) ;

			if ( danger_val < 0.3 )
			{
#if 0
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( through_pass(u) == TRUE ) return ;
				}
#endif
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				else
				{
					if ( MF_pass_forward () == TRUE )	return ;
					if ( MF_pass_side () == TRUE ) return ;
					if ( MF_pass_center () == TRUE ) return ;
#if 0
					for ( Unum u = 5 ; u <= 11 ; ++ u )
					{
						if ( pass_centering ( u ) == TRUE ) return ;
					}
#endif
				}

				if ( DR_None == DribbleTo(vec , 100 , 0 , Mem->CP_dribble_angle_norm,
					  DM_Lazy, FALSE, vec ) )
				{
					if ( MF_pass_side () == TRUE )	return ;
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_center () == TRUE ) return ;

					if ( shoot_near_post() == TRUE ) return ;

					//hold_ball() ;
					kick_ball (Vector ( 52.5 , 0 ) , KM_HardestKick ,TURN_AVOID) ;
					return ;
				}
				return ;
			}
			else if ( danger_val < 0.6 )
			{
#if 0
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( through_pass(u) == TRUE ) return ;
				}
#endif
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}

				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;
#if 0
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( pass_centering ( u ) == TRUE ) return ;
				}
#endif
			}
			else
			{
#if 0
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( through_pass(u) == TRUE ) return ;
				}

				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( pass_centering ( u ) == TRUE ) return ;
				}
#endif
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}

				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE )
				{
					return ;
				}
				else
				{
					if ( Mem->DistanceTo(Vector(36.0,10)) > 10 )
					{
						//hold_ball() ;
						kick_ball (Vector ( 36.0 , 10 ) , KM_HardestKick ,TURN_AVOID) ;
					}
					else
					{
						//hold_ball() ;
						kick_ball (Vector ( 36.0 , -10 ) , KM_HardestKick ,TURN_AVOID) ;
					}

					return ;
				}
			}
		}
		else if ( ball_to_my ( 6.0 ) && Mem->PlayerWithBall() >= 0 )
		{
			if ( get_ball_to_own(buffer) == TRUE )
			{
				return ;
			}
			else
			{
				face_ball() ;
				return ;
			}
		}
		else if ( ball_to_my ( 6.0 ) && Mem->PlayerWithBall() < 0 )
		{
			chase_ball(buffer) ;
			return ;
		}
		else if ( how_many_closer_teammate(Mem->BallAbsolutePosition() ) < 1 && Mem -> PlayerWithBall() <= 0 )
		{
			chase_ball(buffer) ;
			return ;
		}
		else if ( Mem->BallWillBeKickable( 5 , 100 ) )
		{
			if (Mem->PlayerWithBall() <= 0)/*ŨܡäƤ*/
			{
				if ( go_to_point(Mem->BallAbsolutePosition(),buffer) == AQ_ActionNotQueued)
				{
					face_ball() ;
				}
			}
			else
			{
				chase_ball(buffer) ;
			}
			return ;
		}
		else
		{
			if ( Mem->BallPositionValid() )
			{
				if ( Mem->TeammateInOffsidePosition(Mem->MyNumber) )
				{
					if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->my_offside_line
										      - MyProp->offside_line_offset , MyProp->pos.y),buffer) )
					{
						face_ball() ;
					}
					return ;
				}
				else
				{
					if ( Mem -> BallAbsolutePosition().x < -25 )
					{
						if ( go_to_point ( MyProp -> pos , buffer , 40 ) == AQ_ActionNotQueued)
						{
							face_ball() ;
						}
					}
					else if ( Mem->BallX() > Mem->MyX() )
					{
						if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->my_offside_line - 10  , MyProp->pos.y),buffer) )
						{
							face_ball() ;
						}
						return ;
					}
					else
					{
						if ( AQ_ActionNotQueued == go_to_point(Vector(Mem->my_offside_line - 15  , MyProp->pos.y),buffer) )
						{
							face_ball() ;
						}
						return ;
					}
				}
			}
			else
			{
				face_ball();
				return ;
			}
		}
	}
}
