#include <libCMU.h>
#include <zeng.h>
#include <formation.h>

/*	ե᡼Τδؿ	*/
/*					*/
/*	not implemented			*/

Formation::~Formation()
{

}

Formation::Formation()
{

}

#if 0
Formation::Formation()
{
/*եɤν*/
	int i , j ;
	for ( i = 0 ; i < 12 ; ++ i )
	{
		for (j = 0 ; j < 7 ; ++ j )
		{
			if ( i == 0 || i == 11 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			if ( j == 0 || j == 5 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			field[i][j] = 0 ;
			pass[i][j] = 0 ;
			formation[i][j] = 0 ;
		}
	}

	float l = 0 , r = 0 , t = 0 , b = 0 ;

	l = - Mem->SP_pitch_length * 2.0 ;
	r = l + Mem->SP_pitch_length / 10.0 ;
	for ( int i = 1 ; i < 10 ; ++ i )
	{
		t = - Mem->SP_pitch_width * 2.0 ;
		b = t + Mem->SP_pitch_width / 5.0 ;
		for ( int j = 1; j < 5 ; ++ j )
		{
			Rectangle rect ( l , r , t , b ) ;
			field_rect[i][j] = rect ;
			pass_rect[i][j] = rect ;
			formation_rect[i][j] = rect ;

			t += Mem->SP_pitch_width / 5.0 ;
			b = t + Mem->SP_pitch_width / 5.0 ;
		}

		l += Mem->SP_pitch_length / 10.0 ;
		r = l + Mem->SP_pitch_length / 10.0 ;
	}
}
#endif

void Formation::init ( void )
{
/*եɤν*/
	int i , j ;
	for ( i = 0 ; i < 12 ; ++ i )
	{
		for (j = 0 ; j < 7 ; ++ j )
		{
			if ( i == 0 || i == 6 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			if ( j == 0 || j == 11 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			field[i][j] = 0 ;
			pass[i][j] = 0 ;
			formation[i][j] = 0 ;
		}
	}

	float l = 0 , r = 0 , t = 0 , b = 0 ;

	l = - Mem->SP_pitch_length / 2.0 ;
	r = l + Mem->SP_pitch_length / 10.0 ;
	for ( int i = 1 ; i < 11 ; ++ i )
	{
		t = - Mem->SP_pitch_width / 2.0 ;
		b = t + Mem->SP_pitch_width / 5.0 ;
		for ( int j = 1; j < 6 ; ++ j )
		{
			Rectangle rect ( l , r , t , b ) ;
			field_rect[i][j] = rect ;
			pass_rect[i][j] = rect ;
			formation_rect[i][j] = rect ;

			t += Mem->SP_pitch_width / 5.0 ;
			b = t + Mem->SP_pitch_width / 5.0 ;
		}

		l += Mem->SP_pitch_length / 10.0 ;
		r = l + Mem->SP_pitch_length / 10.0 ;
	}
}

void Formation::init_value ( void )
{
/*եɤν*/

	for ( int i = 0 ; i < 12 ; ++ i )
	{
		for ( int j = 0 ; j < 7 ; ++ j )
		{
			if ( i == 0 || i == 11 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			if ( j == 0 || j == 6 )
			{
				field[i][j] = -999 ;
				pass[i][j] = -999 ;
				formation[i][j] = -999 ;
			}

			field[i][j] = 0 ;
			pass[i][j] = 0 ;
			formation[i][j] = 0 ;
		}
	}
}

void Formation::update_value( void )
{
	Vector v ;

//	init_value() ;
	for (Unum e = 1; e <= 11; e++)
	{
		if (Mem->OpponentPositionValid(e))
		{
			v = Mem->OpponentAbsolutePosition(e) ;
			for ( int i = 1 ; i < 11 ; ++ i )
			{
				for ( int j = 1 ; j < 6 ; ++ j )
				{
					field[i][j] -= 0.5 * FIELD_VAL;
					pass[i][j] -= 0.5 * PASS_VAL ;
					formation[i][j] -= 0.5 * FORMATION_VAL;

					if ( (field_rect[i][j]).IsWithin ( v ) )
					{
						field[i][j] += FIELD_VAL_E ;
						field[i-1][j-1] += FIELD_VAL_E / 3.0 ;
						field[i-1][j] += FIELD_VAL_E / 2.0 ;
						field[i-1][j+1] += FIELD_VAL_E / 3.0 ;
						field[i][j-1] += FIELD_VAL_E / 2.0 ;
						field[i][j+1] += FIELD_VAL_E / 2.0 ;
						field[i+1][j-1] += FIELD_VAL_E / 3.0 ;
						field[i+1][j] += FIELD_VAL_E / 2.0 ;
						field[i+1][j+1] += FIELD_VAL_E / 3.0 ;
					}

					if ( (pass_rect[i][j]).IsWithin ( v ) )
					{
						pass[i][j] += PASS_VAL_E ;
						pass[i-1][j-1] += PASS_VAL_E /3.0;
						pass[i-1][j] += PASS_VAL_E /2.0;
						pass[i-1][j+1] += PASS_VAL_E /3.0;
						pass[i][j-1] += PASS_VAL_E /2.0;
						pass[i][j+1] += PASS_VAL_E /2.0;
						pass[i+1][j-1] += PASS_VAL_E /3.0;
						pass[i+1][j] += PASS_VAL_E /2.0;
						pass[i+1][j+1] += PASS_VAL_E /3.0;
					}

					if ( (formation_rect[i][j]).IsWithin ( v ) )
					{
						formation[i][j] += FORMATION_VAL_E ;
						formation[i-1][j-1] += FORMATION_VAL_E /3.0 ;
						formation[i-1][j] += FORMATION_VAL_E /2.0;
						formation[i-1][j+1] += FORMATION_VAL_E /3.0;
						formation[i][j-1] += FORMATION_VAL_E /2.0;
						formation[i][j+1] += FORMATION_VAL_E /2.0;
						formation[i+1][j-1] += FORMATION_VAL_E /3.0;
						formation[i+1][j] += FORMATION_VAL_E /2.0;
						formation[i+1][j+1] += FORMATION_VAL_E /3.0;
					}
				}
			}
		}

		if (Mem->TeammatePositionValid(e))
		{
			v = Mem->TeammateAbsolutePosition(e) ;
			for ( int i = 1 ; i < 11 ; ++ i )
			{
				for ( int j = 1 ; j < 6 ; ++ j )
				{
					if ( (field_rect[i][j]).IsWithin ( v ) )
					{
						field[i][j] += FIELD_VAL ;
						field[i-1][j-1] += FIELD_VAL / 3.0 ;
						field[i-1][j] += FIELD_VAL / 2.0 ;
						field[i-1][j+1] += FIELD_VAL / 3.0 ;
						field[i][j-1] += FIELD_VAL / 2.0 ;
						field[i][j+1] += FIELD_VAL / 2.0 ;
						field[i+1][j-1] += FIELD_VAL / 3.0 ;
						field[i+1][j] += FIELD_VAL / 2.0 ;
						field[i+1][j+1] += FIELD_VAL / 3.0 ;
					}

					if ( (pass_rect[i][j]).IsWithin ( v ) )
					{
						pass[i][j] += PASS_VAL ;
						pass[i-1][j-1] += PASS_VAL /3.0;
						pass[i-1][j] += PASS_VAL /2.0;
						pass[i-1][j+1] += PASS_VAL /3.0;
						pass[i][j-1] += PASS_VAL /2.0;
						pass[i][j+1] += PASS_VAL /2.0;
						pass[i+1][j-1] += PASS_VAL /3.0;
						pass[i+1][j] += PASS_VAL /2.0;
						pass[i+1][j+1] += PASS_VAL /3.0;
					}

					if ( (formation_rect[i][j]).IsWithin ( v ) )
					{
						formation[i][j] += FORMATION_VAL ;
						formation[i-1][j-1] += FORMATION_VAL /3.0 ;
						formation[i-1][j] += FORMATION_VAL /2.0;
						formation[i-1][j+1] += FORMATION_VAL /3.0;
						formation[i][j-1] += FORMATION_VAL /2.0;
						formation[i][j+1] += FORMATION_VAL /2.0;
						formation[i+1][j-1] += FORMATION_VAL /3.0;
						formation[i+1][j] += FORMATION_VAL /2.0;
						formation[i+1][j+1] += FORMATION_VAL /3.0;
					}
				}
			}
		}
	}

	if ( Mem->BallPositionValid() )
	{
		Vector v ;
		v = Mem->BallAbsolutePosition() ;
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( (field_rect[i][j]).IsWithin ( v ) )
				{
					field[i][j] += FIELD_VAL_B ;
					field[i-1][j-1] += FIELD_VAL_B / 3.0 ;
					field[i-1][j] += FIELD_VAL_B / 2.0 ;
					field[i-1][j+1] += FIELD_VAL_B / 3.0 ;
					field[i][j-1] += FIELD_VAL_B / 2.0 ;
					field[i][j+1] += FIELD_VAL_B / 2.0 ;
					field[i+1][j-1] += FIELD_VAL_B / 3.0 ;
					field[i+1][j] += FIELD_VAL_B / 2.0 ;
					field[i+1][j+1] += FIELD_VAL_B / 3.0 ;
				}

				if ( (pass_rect[i][j]).IsWithin ( v ) )
				{
					pass[i][j] += PASS_VAL_B ;
					pass[i-1][j-1] += PASS_VAL_B /3.0;
					pass[i-1][j] += PASS_VAL_B /2.0;
					pass[i-1][j+1] += PASS_VAL_B /3.0;
					pass[i][j-1] += PASS_VAL_B /2.0;
					pass[i][j+1] += PASS_VAL_B /2.0;
					pass[i+1][j-1] += PASS_VAL_B /3.0;
					pass[i+1][j] += PASS_VAL_B /2.0;
					pass[i+1][j+1] += PASS_VAL_B /3.0;
				}

				if ( (formation_rect[i][j]).IsWithin ( v ) )
				{
					formation[i][j] += FORMATION_VAL_B ;
					formation[i-1][j-1] += FORMATION_VAL_B /3.0 ;
					formation[i-1][j] += FORMATION_VAL_B /2.0;
					formation[i-1][j+1] += FORMATION_VAL_B /3.0;
					formation[i][j-1] += FORMATION_VAL_B /2.0;
					formation[i][j+1] += FORMATION_VAL_B /2.0;
					formation[i+1][j-1] += FORMATION_VAL_B /3.0;
					formation[i+1][j] += FORMATION_VAL_B /2.0;
					formation[i+1][j+1] += FORMATION_VAL_B /3.0;
				}
			}
		}
	}
}

#if 0
void Formation::debug_rect ( void )
{
	cout << "--------------------" << endl ;
	for ( int j = 1 ; j < 11 ; ++ j )
	{
		for ( int i = 1 ; i < 6 ; ++ i )
		{
			field_rect[i][j].Print() ;
			pass_rect[i][j].Print() ;
			formation_rect[i][j].Print() ;
		}
	}
}
#endif
void Formation::debug_print ( void )
{

	printf("FIELD::\n") ;
	for ( int j = 1 ; j < 6 ; ++ j )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			printf ( "%4.1f " , field[i][j] ) ;
		}
		printf("\n") ;
	}
	printf("\nPASS::\n") ;
	for ( int j = 1 ; j < 6 ; ++ j )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			printf ( "%4.1f " , pass[i][j] ) ;
		}
		printf("\n") ;
	}
	printf("\nFORMATION::\n") ;
	for ( int j = 1 ; j < 6 ; ++ j )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			printf ( "%4.1f " , formation[i][j] ) ;
		}
		printf("\n") ;
	}
}

Bool Formation::is_in_rect ( Formation::RECT_TYPE type , float x , float y , int * ri , int * rj )
{
	if ( type == FIELD )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( (field_rect[i][j]).IsWithin ( Vector ( x , y ) ) )
				{
					*ri = i ;
					*rj = j ;
					return ( TRUE ) ;
				}
			}
		}
	}
	else if ( type == PASS )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( (pass_rect[i][j]).IsWithin ( Vector ( x , y ) ) )
				{
					*ri = i ;
					*rj = j ;
					return ( TRUE ) ;
				}
			}
		}
	}
	else if ( type == FORMATION )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( (formation_rect[i][j]).IsWithin ( Vector ( x , y ) ) )
				{
					*ri = i ;
					*rj = j ;
					return ( TRUE ) ;
				}
			}
		}
	}
	else
	{
		return ( FALSE ) ;
	}

}

Bool Formation::get_max ( Formation::RECT_TYPE type , int * ri , int * rj )
{
	double max = -999 ;
	int flag = 1 ;

	if ( type == FIELD )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( field[i][j] > max )
				{
					max = field[i][j] ;
					*ri = i ;
					*rj = j ;
					flag = -1 ;
				}
			}
		}

		if ( flag == -1 )
		{
			return ( TRUE ) ;
		}
	}
	else if ( type == PASS )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( pass[i][j] > max )
				{
					max = pass[i][j] ;
					*ri = i ;
					*rj = j ;
					flag = -1 ;
				}
			}
		}

		if ( flag == -1 )
		{
			return ( TRUE ) ;
		}
	}
	else if ( type == FORMATION )
	{
		for ( int i = 1 ; i < 11 ; ++ i )
		{
			for ( int j = 1 ; j < 6 ; ++ j )
			{
				if ( formation[i][j] > max )
				{
					max = formation[i][j] ;
					*ri = i ;
					*rj = j ;
					flag = -1 ;
				}
			}
		}

		if ( flag == -1 )
		{
			return ( TRUE ) ;
		}
	}
	else
	{
		return ( FALSE ) ;
	}

}
